--this file, as well as object.lua is only for demo purposes

local objects = {}

--create a bunch of objects with different tags
--each object will get self.id=i
for i=1, 100 do

	objects[i] = Object.new(i)

	local tags = {}
	local num = math.fmod(i,5)

	if num == 0 then
		tags = "one"
	elseif num == 1 then
		tags = {"two", "three"}
	elseif num == 2 then
		tags = {"three", "four", "five"}
	elseif num == 3 then
		tags = "a"
	elseif num == 4 then
		tags = 1
	else
		print("something went wrong")
	end

	objects[i].tags = tags

end

--choose one of the below

results = searchX(objects, "tags", {"three"})
--results = searchX(objects, "tags", {1})
--results = searchX(objects, "tags", {"three", "four"})
--results = searchX(objects, "tags", {"a"})
--results = searchX(objects, "id", {98})

print("")

--IF YOU TEST WITH MORE THAN 1000 OBJECTS, OMIT THE PRINT LOOP!!! or your PC might freeze
for i=1, #results do
	results[i]:sayHello()
end

print("\ntotal objects: "..#objects)
print("results:"..#results)